#include <stdio.h>
#include "ptt.h"
#include "xor.h"

void
init_xor(){
    int i;
    for(i=2000; i<sizeof(xor); i++)
	xor[i] = (xor[i-2000] ^ xor[i-1001] ^ xor[i-999]);
}

/* decrypt and expand secret into plain */
/* both secret and plain are changed! */
/* we may have to realloc plain */
void
decrypt(string secret, string *plain, char *which, char *name) {
    uchar lempel_ziv[4096], lzcnt, lznext;
    int i, j, ct, bitmap, lzlow, lzptr, lzptr0;

    plain->lth = 0;

    /* decrypt */
    for (i=0; i<secret.lth; i++)
      secret.p[i] ^= xor[i];

    /* decompress */
    /* in Heerenveen en in Voorhout worden 7 spaties geciteerd */
    /* in asd.as zelfs 13 en in asmrbg.as 14 en in ztm.as 18 */
#define SPACECT 18
    lzptr = 0xfee - SPACECT;
    for (ct=0; ct < SPACECT; ct++)
      lempel_ziv[lzptr++] = ' ';

    lznext = 0;
    bitmap = 1;

    i = 0;
    while(i < secret.lth) {
	lzptr0 = lzptr;

	if (lznext) {
	    lznext = 0;
	    lzlow |= ((secret.p[i] & 0xf0) << 4);
	    lzcnt = 3 + (secret.p[i] & 0x0f);
	    if(lzlow < 0xfee - SPACECT && (lzlow + 0x1000 > lzptr)) {
		fprintf(stderr, "Uninitialized part of lempel_ziv array used.\n");
		fprintf(stderr, "file: %s.%s lzlow=0x%x lzptr=0x%x\n",
			name, which, lzlow, lzptr);
		exit(1);
	    }
	    while(lzcnt--) {
		j = lempel_ziv[lzlow++ & 0xfff];
		lempel_ziv[lzptr++ & 0xfff] = j;
	    }
	} else if (bitmap == 1) {
	    bitmap = 0x100 + secret.p[i];
	} else {
	    if ((bitmap & 1) == 0) {
		lznext = 1;
		lzlow = secret.p[i];
	    } else {
		j = secret.p[i];
		lempel_ziv[lzptr++ & 0xfff] = j;
	    }
	    bitmap >>= 1;
	}
	i++;

	while(lzptr0 != lzptr) {
	    if(plain->lth == plain->alloclth)
	      grow_string(plain, 1000);

	    j = lempel_ziv[lzptr0++ & 0xfff];
	    (plain->p)[plain->lth++] = j;
	}
    }
}
