#include <stdio.h>
#include <getopt.h>
#include <ctype.h>
#include <string.h>
#include <locale.h>
#include "ptt.h"

/* zoek naar het volgende */
struct {
    char *kopje;		/* amusement en erotiek# */
    char *naam;			/* LINT */
    char *initialen;		/* J H. */
    char *prefix;		/* VAN  */
    char *stad;
    char *straat;
    char *prenummer;
    char *huisnummer;
    char *subnummer;
    uchar postcode[6];
    uchar kengetal[5];
    char *telefoonnummer;
    uchar type;			/* spatie: gewoon, A: auto, F: fax, T: telex, N: 06 */
    int not06;
    int block;			/* bloknummer in stad */
} x;

/* gevonden */
struct {
    uchar offset[3];		/* high order last */
    uchar count[2];
				/* count[1] != 0 only in two cases:
				 * STUDENTENHUISVESTING GRONINGEN (1) and
				 * STUDENTENHUISVESTING ROTTERDAM (9)
				 */
    uchar type;			/* takes 5 values: " AFTN" */
    uchar idx[2];
    uchar kengetal[4];
    uchar postcode[6];

    uchar kopje[100];
    uchar naam[100];
    uchar initialen[100];
    uchar prefix[100];
    uchar rest[100];
    uchar straat[100];
    uchar prenummer[100];	/* ,ww ,to ,ab ,by */
#define HNRSZ 10
    /* Huisnummers zijn nooit langer dan 9 symbolen: 39006CARV, GREENPOIN,
       TO130BOOT, AALSCHOLV enz. duiden erop dat de PTT trunceert bij 9. */
    uchar huisnummer[HNRSZ];
    uchar subnummer[100];
    uchar telefoonnummer[100];

    uchar dosnaam[12];		/* 8+3+1 */
    uchar stad[100];

    int block;
} y;    

int selector_used = 0;
int opt_dumpwpl = 0;
int opt_ds = 1;			/* lees ook .ds file met extra info */
int only_one = 0;
int geen_kop = 0;
char deze_naam[100];
char vorige_naam[100];

#define SP (' ')
uchar strip[256] = {
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
  SP,  SP,  SP,  SP,  SP,  SP,  SP,  SP,
  SP,  SP,  SP,  SP,  SP,  SP,  SP,  SP,
 '0', '1', '2', '3', '4', '5', '6', '7',
 '8', '9',  SP,  SP,  SP,  SP,  SP,  SP,
 '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
 'X', 'Y', 'Z',  SP,  SP,  SP,  SP,  SP,
  SP, 'A', 'B', 'C', 'D', 'E', 'F', 'G',
 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
 'X', 'Y', 'Z',  SP,  SP,  SP,  SP,  SP,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
 0, 0, 0, 0, 0, 0, 0, 0,
  SP,  SP,  SP,  SP,  SP,  SP,  SP,  SP,
  SP,  SP,  SP,  SP,  SP,  SP,  SP,  SP,
  SP,  SP,  SP,  SP,  SP,  SP,  SP,  SP,
  SP,  SP,  SP,  SP,  SP,  SP,  SP,  SP,
 'A', 'A', 'A', 'A', 'A', 'A',  SP, 'C',
 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I',
 'D', 'N', 'O', 'O', 'O', 'O', 'O',  SP,
 'O', 'U', 'U', 'U', 'U', 'Y',  SP,  SP,
 'A', 'A', 'A', 'A', 'A', 'A',  SP, 'C',
 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I',
 'D', 'N', 'O', 'O', 'O', 'O', 'O',  SP,
 'O', 'U', 'U', 'U', 'U', 'Y',  SP,  'Y'
};


void
usage(){
    fprintf(stderr, "\

Aanroep: ptt [opties] [naam].

Quote een string die spaties bevat:
	ptt -w \"krimpen aan den ijssel\"
Geef etages e.d. aan met een /:
	ptt -h 21/hs

Zonder opties wordt het telefoonboek van heel Nederland afgezocht
naar de opgegeven naam. Is geen naam opgegeven dan worden de
gegevens voor alle namen afgedrukt.
Opties gevolgd door een tekst waarde:
  -n of --naam:        wordt gevolgd door de naam (zonder initialen of vd)
  -i of --initialen:   wordt gevolgd door initialen (zonder punten)
  -w of --woonplaats:  wordt gevolgd door 06 of door de gewenste stad
  -p of --postcode:    wordt gevolgd door de postcode (4 of 6 symbolen)
  -s of --straat:      wordt gevolgd door de straat
  -h of --huisnummer:  wordt gevolgd door het huisnummer
  -o of --onderwerp:   wordt gevolgd door kopje (\"scholen\", \"amusement en erotiek\")
  -t of --type:        wordt gevolgd door G, T, F, A of N
		(voor gewone nummers, telex, fax, auto of 06-niet-auto)
  -k of --kengetal:    het kengetal voor de woonplaats
  -= of --telefoonnummer: het abonneenummer

Logische opties:
  -0 of --geen06:      06-nummers niet gewenst
  -1 of --slechts-1:   stop zodra een passende bestandsregel is gevonden
  -# of --geen-kop:    druk geen onderwerpskopregels af
  -F of --fax:         fax nummer gewenst
  -T of --telex:       telex nummer gewenst
  -A of --auto:        mobiel nummer gewenst
  -N of --06-niet-auto 06- maar niet mobiel gewenst

  -W of --wpl:         druk (alleen) de woonplaatsenlijst af
  -x of --extra:       druk geen extra informatie af
  -? of --help:        druk deze hulptekst af

Voorts zijn er nog de meer obscure opties -B of --blok
die alleen voor testdoeleinden bedoeld zijn.
");
    exit(1);
}

int
main(int argc, char **argv){
    int c;
    const char *short_opts = "n:i:p:w:s:h:o:t:k:=:01#FTANWB:x?";
    const struct option long_opts[] = {
	{ "naam",	required_argument, NULL, 'n' },
	{ "initialen",	required_argument, NULL, 'i' },
	{ "woonplaats",	required_argument, NULL, 'w' },
	{ "postcode",	required_argument, NULL, 'p' },
	{ "straat",	required_argument, NULL, 's' },
	{ "huisnummer",	required_argument, NULL, 'h' },
	{ "onderwerp",	required_argument, NULL, 'o' },
	{ "type",	required_argument, NULL, 't' },
	{ "kengetal",	required_argument, NULL, 'k' },
	{ "telefoonnummer", required_argument, NULL, '=' },

	{ "geen06",	no_argument, NULL, '0' },
	{ "slechts-1",	no_argument, NULL, '1' },
	{ "geen-kop",	no_argument, NULL, '#' },
	{ "fax",	no_argument, NULL, 'F' },
	{ "telex",	no_argument, NULL, 'T' },
	{ "auto",	no_argument, NULL, 'A' },
	{ "06-niet-auto", no_argument, NULL, 'N' },
	{ "extra",	no_argument, NULL, 'x' },
	{ "wpl",	no_argument, NULL, 'W' },
	{ "blok",	required_argument, NULL, 'B' },

	{ "help",	no_argument, NULL, '?' },
	{ NULL, 0, NULL, 0 }
    };

    progname = argv[0];

    setlocale(LC_CTYPE,"");	/* used only for tolower() */

    init_xor();

    /* no desires as yet */
    x.naam = x.initialen = x.prefix = x.stad = x.straat = x.prenummer = "";
    x.huisnummer = x.subnummer = x.telefoonnummer = x.kopje = "";
    x.postcode[0] = x.postcode[4] = x.kengetal[0] = x.type = 0;
    x.block = 0;

    /* collect restrictions */
    while((c = getopt_long(argc, argv,
			   short_opts, long_opts, NULL)) != -1) {
	switch(c) {
	  case 'n':
	    x.naam = optarg;
	    break;
	  case 'i':
	    x.initialen = optarg;
	    break;
	  case 'w':
	    x.stad = optarg;
	    break;
	  case 'p':
	    { int l;
	      l = strlen(optarg);
	      if(l != 4 && l != 6)
		  fatal("Na de -p optie verwacht ik 4 of 6 symbolen van de postcode.\n");
	      strncpy(&x.postcode[0], optarg, l);
	      break;
	    }
	  case 's':
	    x.straat = optarg;
	    break;
	  case 'h':
	    { char *sp;
	      x.huisnummer = optarg;
	      if((sp = index(optarg, '/')) != 0) {
		  *sp++ = 0;
		  x.subnummer = sp;
	      }
	    }
	    break;
	  case 'o':
	    x.kopje = optarg;
	    break;
	  case 't':
	    x.type = optarg[0];
	    if (x.type == '_' || x.type == 'G')
	      x.type = ' ';
	    if (!optarg[0] || optarg[1] || !index(" _GAFTN", optarg[0]))
		fatal("Na de -t (type) optie verwacht ik een van de types A, F, T, N, G.\n");
	    break;
	  case 'k':
	    { unsigned int l;
	      l = strlen(optarg);
	      if(l > 5)
		  fatal("Na de -k (kengetal) optie verwacht ik een kengetal van ten hoogste 5 cijfers\n");
	      strncpy(&x.kengetal[0], "     ", 5);
	      strncpy(&x.kengetal[5-l], optarg, l);
	      if (optarg[0] != '0') {
		  if(l == 5)
		    fatal("Een kengetal van vijf cijfers moet met een 0 beginnen\n");
		  else
		    x.kengetal[4-l] = '0';
	      }
	      break;
	    }
	  case '=':
	    x.telefoonnummer = optarg;
	    break;
	  case '0':
	    x.not06 = 1;
	    break;
	  case '1':
	    only_one = 1;
	    break;
	  case '#':
	    geen_kop = 1;
	    break;
	  case 'F':
	    x.type = 'F';
	    break;
	  case 'T':
	    x.type = 'T';
	    break;
	  case 'A':
	    x.type = 'A';
	    break;
	  case 'N':
	    x.type = 'N';
	    break;
	  case 'W':
	    opt_dumpwpl = 1;
	    break;
	  case 'B':
	    x.block = atoi(optarg);
	    selector_used = 1;
	    break;
	  case 'x':
	    opt_ds = 0;
	    break;
	  case '?':
	    usage();
	    exit(1);
	  default:
	    fatal("strange option - program bug - c=%d\n", c);
	}
    }

    if (optind < argc) {	/* naam */
	if(!x.naam[0])
	  x.naam = argv[optind++];
	if (optind < argc)
	    fatal("Onbekende optie %s\n", argv[optind]);
    }

    /* Alle directories van de CD (afgezien van wat onder 0 staat)
       komen ook in wpl.dat voor, maar niet omgekeerd. */
    read_wpl();
    return 0;
}

void
read_wpl(){
    FILE *f;
    struct wpl wpl;
    int seq = 0, seq0;
    int offset = 3*sizeof(struct wpl);

    f = myopen("/cd/wpl.dat");
    myseek(f, offset, SEEK_SET);
    while(fread(&wpl, sizeof(wpl), 1, f)) {
	seq0 = c2toi(wpl.seq);
	if (opt_dumpwpl) {
	    if(seq++ != seq0) {
		printf("** unexpected sequence number **\n");
		seq = seq0+1;
	    }
	    /*
	     * Check for nonsense - expect trailing zeroes only.
	     * We find that records 1 and 2 are entirely null, while
	     * record 0 is null except for the first field, which is:
	     * 0141 0 0 0 075 0 0 0 0 0  0 0 0 0 0 0 0 0 01 0
	     *   a         =                             ^A
	     *   97        61                             1
	     * 051 035 0 0 0 0 0 0 0173 0363  06 0 0173 0363 06 0 051 035 0 0
	     *  )   ^]               {   o'   ^F     {   o'  ^F    )   ^]
	     *  41  29              123  243   6    123  243  6    41  29
	     *   7465                 455547
	     * I don't know whether this has any meaning.
	     */
	    trailck(wpl.wpl, 1, 40, "wpl");
	    trailck(wpl.kengetal, 5, 5, "kengetal");
	    trailck(wpl.lowpc, 4, 4, "lowpc");
	    trailck(wpl.highpc, 4, 4, "highpc");
	    trailck(wpl.dosname, 6, 6, "dosnaam");

	    if(!strncmp(wpl.lowpc, wpl.highpc, 4))
	      printf("%4d. %.6s %.5s %.4s      %s\n", seq0,
		     wpl.dosname, wpl.kengetal, wpl.lowpc, wpl.wpl);
	    else
	      printf("%4d. %.6s %.5s %.4s-%.4s %s\n", seq0,
		     wpl.dosname, wpl.kengetal, wpl.lowpc, wpl.highpc, wpl.wpl);
	} else {
	    char *p;
	    if((p = index(wpl.dosname,' ')) != 0)
	      *p = 0;

	    /*
	     * Does this city satisfy our request?
	     */
	    if (x.not06 && !strncmp(wpl.kengetal, "   06", 5))
	      continue;
	    if (x.stad[0] && strcasecmp(x.stad, wpl.wpl) && strcasecmp(x.stad, wpl.dosname))
	      continue;

	    if (x.postcode[0] && (strncmp(wpl.lowpc, &x.postcode[0], 4) > 0 ||
				  strncmp(wpl.highpc, &x.postcode[0], 4) < 0))
	      continue;
	    if (x.kengetal[0] && strncmp(&x.kengetal[0], wpl.kengetal, 5))
	      continue;

	    strcpy(y.stad, wpl.wpl);

	    do_city(&wpl.dosname[0]);
	}
	offset += sizeof(struct wpl);
    }
}

struct gezien {
    struct gezien *nxt;
    char dosnaam[7];
} *(gez[27]);

int
gezien(char *s) {
    int i;
    struct gezien *gp;

    if(*s >= 'A' && *s <= 'Z')
      i = *s - '@';
    else
      i = 0;

    if(gez[i]) {
	gp = gez[i];
	while(1) {
	    if(!strcmp(gp->dosnaam, s))
	      return 1;
	    if(! gp->nxt)
	      break;
	    gp = gp->nxt;
	}
	gp->nxt = (struct gezien *) myalloc(sizeof(struct gezien));
	gp = gp->nxt;
    } else {
	gp = gez[i] = (struct gezien *) myalloc(sizeof(struct gezien));
    }
    gp->nxt = 0;
    strcpy(gp->dosnaam, s);
    return(0);
}

int lastblock, lastitem;

void
do_city(char *s) {
    FILE *f, *ff;
    char dosnaam[7];
    char stad_am[100];
    char stad_dm[100];
    struct a buf;
    int block, recno, lth, i;
    long sz;

    for(i=0; i<6; i++)
      dosnaam[i] = tolower(s[i]);
    do {
	dosnaam[i] = 0;
    } while(dosnaam[--i] == ' ');

    strcpy(y.dosnaam, &dosnaam[0]);

    /* In wpl.dat staan de steden niet geheel op alfabetische volgorde,
       dus we moeten controleren of we niets dubbel doen, en alleen
       vergelijken met de vorige stad is niet voldoende. */
    if (gezien(&dosnaam[0]))
      return;

    sprintf(stad_am, "/cd/%c/%s/%s.am", dosnaam[0], dosnaam, dosnaam);
    f = fopen(stad_am, "r");
    if (f == NULL) {
#if 0
	/* this happens for the 8 files
	   amland, merk, tschel, hne, lzl, corle, henxel, huppel */
	perror(stad_am);
#endif
	return;
    }
    sprintf(stad_dm, "/cd/%c/%s/%s.dm", dosnaam[0], dosnaam, dosnaam);
    ff = myopen(stad_dm);
    sz = mysize(ff);		/* only used for PTT bug checking */

    vorige_naam[0] = 0;

    if (x.block) {
	y.block = x.block;
	myseek(f, x.block * sizeof(struct a), SEEK_SET);
	if(fread(&buf,sizeof(struct a),1,f) != 1) {
	    perror(stad_am);
	    exit(1);
	}
	myseek(ff, c4toi(buf.offset), SEEK_SET);
	do_block(ff, c2toi(buf.length));
    } else {
	block = 0;
	recno = 0;

	while(fread(&buf,sizeof(struct a),1,f) == 1) {
	    if(c4toi(buf.offset) != block){
		fprintf(stderr, "record %d: read offset %d, expected %d\n",
		       recno, c4toi(buf.offset), block);
		exit(1);
	    }

	    y.block = recno;
	    lth = c2toi(buf.length);
	    myseek(ff, c4toi(buf.offset), SEEK_SET);

	    block += lth;
	    recno++;
	    lastblock = (block == sz);

	    do_block(ff, lth);		/* uses lastblock */
	}
	if (!lastblock)
	  fprintf(stderr, "Strange... long dm file?\n");
    }
    fclose(f);
    fclose(ff);
}

string zerostring;
string dm_pp;

void
do_block(FILE *ff, int lth) {
    uchar *buff = myalloc(lth);
    int i, j, k, ct, cths, ctsp;
    string ss;
    enum { Eoffset, Ecount, Etype, Eidx, Ekengetal, Epostcode, Enaam,
	   Einitialen, Eprefix, Erest, Estraat, Eprenummer, Ehuisnummer, Esubnummer,
	   Etelno } state;

    if(fread(buff, 1, lth, ff) < lth) {
	perror("error reading block");
	exit(1);
    }

    ss.lth = ss.alloclth = lth;
    ss.p = buff;
    decrypt(ss, &dm_pp, "am", y.dosnaam);
    free(buff);

    state = Eoffset;
    i = ct = 0;

    while(i < dm_pp.lth) {
	k = (dm_pp.p)[i++];
	j = tolower(k);

	switch(state) {
	  case Eoffset:
	    y.offset[ct++] = k;
	    if (ct == 3) {
		state = Ecount;
		ct = 0;
	    }
	    break;
	    
	  case Ecount:
	    y.count[ct++] = k;
	    if (ct == 2)
	      state = Etype;
	    break;
	    
	  case Etype:
	    y.type = k;
	    state = Eidx;
	    ct = 0;
	    break;
	    
	  case Eidx:
	    y.idx[ct++] = k;
	    if(ct == 2) {
		state = Ekengetal;
		ct = 0;
	    }
	    break;
	    
	  case Ekengetal:
	    y.kengetal[ct++] = j;
	    if(ct == 4) {
		state = Epostcode;
		ct = 0;
	    }
	    break;
	    
	  case Epostcode:
	    y.postcode[ct++] = j;
	    if(ct == 6) {
		state = Enaam;
		y.kopje[0] = 0;
		ct = 0;
	    }
	    break;
	    
	  case Enaam:
	    if(ct >= 100)
		fatal("naam te lang?\n%.100s\n", y.naam);
	    if(j == '#') {
		if (y.kopje[0])
		  fatal("twee kopjes bij een naam?");
		y.naam[ct] = 0;
		strcpy(y.kopje, y.naam);
		ct = 0;
	    } else if(j == ',') {
		y.naam[ct] = 0;
		state = Einitialen;
		ct = 0;
	    } else {
		y.naam[ct++] = j;
	    }
	    break;
	    
	  case Einitialen:
	    if(ct >= 100)
		fatal("initialen te lang??\n");
	    if(j == '.') {
		y.initialen[ct] = 0;
		state = Eprefix;
		ct = 0;
	    } else {
		y.initialen[ct++] = j;
	    }
	    break;
	    
	  case Eprefix:
	    if(ct >= 100)
		fatal("prefix te lang??\n");
	    if(j == ',') {
		y.prefix[ct] = 0;
		state = Erest;
		ct = 0;
	    } else {
		y.prefix[ct++] = j;
	    }
	    break;
	    
	  case Erest:
	    if(ct >= 100)
		fatal("rest te lang??\n");
	    if(j == '@') {
		y.rest[ct] = 0;
		state = Estraat;
		ct = 0;
	    } else {
		y.rest[ct++] = j;
	    }
	    break;
	    
	  case Estraat:
	    if(ct >= 100)
		fatal("straat te lang??\n");
	    if(j == ',') {
		y.straat[ct] = 0;
		state = Eprenummer;
		ct = 0;
	    } else if(j == '@') {
		y.straat[ct] = 0;
		y.prenummer[0] = 0;
		state = Ehuisnummer;
		ct = 0;
	    } else {
		y.straat[ct++] = j;
	    }
	    break;

	  case Eprenummer:
	    if(ct >= 100)
	      fatal("prenummer te lang?");
	    if(j == '@') {
		y.prenummer[ct] = 0;
		state = Ehuisnummer;
		ct = 0;
	    } else {
		y.prenummer[ct++] = j;
	    }
	    break;
	    
	  case Ehuisnummer:
	    if(ct >= HNRSZ)
		fatal("huisnummer te lang??\n");
	    if(j == ' ') {
		y.huisnummer[ct] = 0;
		state = Esubnummer;
		cths = ct;
		ctsp = 1;
		ct = 0;
	    } else if(j == '@') {
		y.huisnummer[ct] = 0;
		y.subnummer[0] = 0;
		state = Etelno;
		ct = 0;
	    } else {
		y.huisnummer[ct++] = j;
	    }
	    break;

	  case Esubnummer:
	    if(ct + cths + ctsp >= HNRSZ)
	      fatal("huis+sub is lang %s/%.9s.\n", y.huisnummer, y.subnummer);
	    if(ct >= 100)
		fatal("subnummer te lang??\n");
	    if(ct > 0 || j != ' ') {
		if(j == '@') {
		    y.subnummer[ct] = 0;
		    state = Etelno;
		    ct = 0;
		} else {
		    y.subnummer[ct++] = j;
		}
	    } else
	      ctsp++;
	    break;
	    
	  case Etelno:
	    if(ct >= 100)
		fatal("telefoonnummer te lang??\n");
	    if(j == '@') {
		/* Een entry in Haarlem heeft een @ teveel */
		if(ct == 0 && !strcmp(y.dosnaam, "hlm") &&
		   !strcmp(y.naam, "klugt") &&
		   !strcmp(y.straat, "groningenln") &&
		   !strcmp(y.huisnummer, "12") &&
		   !strcmp(y.subnummer, "122")) {
#if 0
		    fprintf(stderr, "Fixed bug in Haarlem\n");
#endif
		    break;
		}

		y.telefoonnummer[ct] = 0;
		state = Eoffset;
		ct = 0;

		lastitem = (lastblock && i == dm_pp.lth);
		treat_entry();
#if 0
		/* de files zijn ongeveer gesorteerd, maar niet precies */
		/* 06: eerst: _INTIEM MET NATASJA_ dan: _INTIEM MET BIANCA_ */
		/* 06: eerst: _POLITIE RYKS ALARM_ dan: _POLITIE BRABANT NO_*/
		/* 06: eerst: _REEF REEF INFRA BAU_ dan:_REEF INFRA BAU GMBH_*/
		/* de accenten moeten weg; ook moet de kop meegesorteerd */
		{ uchar *s; int l = 0;
		  for(s = y.kopje; *s; s++)
		      deze_naam[l++] = strip[*s];
		  if (l) deze_naam[l++] = SP;
		  for(s = y.naam; *s; s++)
		      deze_naam[l++] = strip[*s];
		  deze_naam[l] = 0;
		  deze_naam[20] = 0;
		  if(strcmp(vorige_naam, deze_naam) > 0)
		    fprintf(stderr, "%s: vorige: _%s_ deze: _%s__[%s]\n",
			    y.dosnaam, vorige_naam, deze_naam, y.naam);
	        }
		strcpy(vorige_naam, deze_naam);
#endif
	    } else {
		y.telefoonnummer[ct++] = j;
	    }
	    break;
	    
	  default:
	    fatal("Impossible state.\n");
	}
    }
}

void
treat_entry(){
    FILE *f = stdout;

    if (!index(" ANTF", y.type))
	fatal("vreemd type %c (0%o)\n", y.type, y.type);

    /* does this satisfy all our conditions? */
    if(x.naam[0] && strcasecmp(y.naam, x.naam))
      goto no;

    if(x.initialen[0] && strcasecmp(y.initialen, x.initialen))
      goto no;

    if(x.straat[0] && strcasecmp(y.straat, x.straat))
      goto no;

    if(x.huisnummer[0] && strcasecmp(y.huisnummer, x.huisnummer))
      goto no;

    if(x.subnummer[0] && strcasecmp(y.subnummer, x.subnummer))
      goto no;

    if(x.type && x.type != y.type)
      goto no;

    if(x.kopje[0] && strcasecmp(y.kopje, x.kopje))
      goto no;

    if(x.not06 && !strncmp(y.kengetal, "  06", 4))
      goto no;
    if(x.kengetal[0] && strncmp(y.kengetal, x.kengetal+1, 4))
      goto no;

    if(x.telefoonnummer[0] && strcmp(y.telefoonnummer, x.telefoonnummer))
      goto no;

    if(x.postcode[0] && strncmp(y.postcode, x.postcode, 4))
      goto no;

    if(x.postcode[4] && strncasecmp(y.postcode+4, x.postcode+4, 2))
      goto no;

    goto yes;

  no:
    selector_used = 1;
    return;
    
  yes:
    fprintf(f, "%c ", y.type);
    fprintf(f, "%.6s ", y.postcode);
    if(y.kengetal[0] == ' ' || y.kengetal[0] == '0')
      fprintf(f, " %.4s", y.kengetal);
    else
      fprintf(f, "0%.4s", y.kengetal);
    fprintf(f, "-%-7.7s", y.telefoonnummer);

    if(!geen_kop && y.kopje[0])
      fprintf(f, "#%s#", y.kopje);
    /* soms staat er bij de initialen een volle naam zoals "Cees"
       dus een punt is niet altijd goed */
    if(y.initialen[0])
      fprintf(f, " %s", y.initialen);
    if(y.prefix[0])
      fprintf(f, " %s", y.prefix);
    fprintf(f, " %s", y.naam);
    if(y.rest[0])
      fprintf(f, ", %s", y.rest);
    if(y.straat[0])
      fprintf(f, ", %s", y.straat);
    if(y.prenummer[0])
      fprintf(f, " %s", y.prenummer);
    if(y.subnummer[0])
      fprintf(f, " %s/%s", y.huisnummer, y.subnummer);
    else if(y.huisnummer[0])
      fprintf(f, " %s", y.huisnummer);
    if(strcmp(y.stad, "06"))
      fprintf(f, ", %s", y.stad);
    printf("\n");

    if (opt_ds && c2toi(y.count))
      get_as_txt(c3toi(y.offset), c2toi(y.count));

    if (only_one)
      exit(0);
}

uchar as_dosnaam[12];
FILE *fas, *fds;
int ds_current_offset;
int ds_block;
struct a as_a;
int as_offset, as_length, as_recno;
string ds_pp;			/* initially 0 */
uchar *ds_ptr;
string last_as_field;		/* sometimes a group of as fields is used twice in a row */
				/* (this may well be a PTT bug) */
int last_as_recno;		/* number of the last one in the group */

int
ds_next_char() {
    if (ds_ptr == ds_pp.p + ds_pp.lth) {
	string ss;

	ds_block += as_length;
	fread(&as_a,sizeof(struct a),1,fas);
	as_offset = c4toi(as_a.offset);
	as_length = c2toi(as_a.length);

	if(as_offset != ds_block)
	    fatal("%s %d: read offset %d, expected %d\n",
		    as_dosnaam, as_recno, as_offset, ds_block);

	if(as_length < 1)
	    fatal("%s %d: block of length %d\n",
		    as_dosnaam, as_recno, as_length);

	as_recno++;
	ss.p = myalloc(as_length);
	ss.lth = ss.alloclth = as_length;
	fread(ss.p, 1, ss.lth, fds);
	decrypt(ss, &ds_pp, "as", as_dosnaam);
	free(ss.p);
	ds_ptr = ds_pp.p;
	if (ds_pp.lth < 1)
	    fatal("%s %d: expanded block of length %d\n",
		    as_dosnaam, as_recno, ds_pp.lth);
    }

    return *ds_ptr++;
}

void
skip_ds_rec(int count) {
    int atct;

    while(count--) {
	atct = 0;
	while(atct < 3)
	  if(ds_next_char() == '@')
	    atct++;
	last_as_recno++;
    }
}

void
get_ds_rec(int count) {
    int j,m,atct;

    m = 0;
    while(count--) {
	atct = 0;
	while(atct < 3) {
	    j = ds_next_char();
	    if(j == '@')
	      atct++;
	    if(m >= last_as_field.alloclth - 1)
	      grow_string(&last_as_field, 1000);
	    last_as_field.p[m++] = j;
	}
	last_as_field.p[m++] = 0;
	last_as_recno++;
    }
}

void
get_as_txt(int offset, int count) {
    int j, m;

    if(fas && strcmp(y.dosnaam, as_dosnaam)) {
	fclose(fas);
	fclose(fds);
	fas = fds = 0;
    }
    if(fas == NULL) {
	char as_naam[100];
	char ds_naam[100];

	sprintf(as_naam, "/cd/%c/%s/%s.as", y.dosnaam[0], y.dosnaam, y.dosnaam);
	fas = myopen(as_naam);
	sprintf(ds_naam, "/cd/%c/%s/%s.ds", y.dosnaam[0], y.dosnaam, y.dosnaam);
	fds = myopen(ds_naam);
	strcpy(as_dosnaam, y.dosnaam);
	ds_current_offset = 0;
	ds_pp.lth = 0;
	ds_ptr = ds_pp.p;
	ds_block = as_length = 0;
	last_as_field = zerostring;
	last_as_recno = -1;
    }

    if (offset < last_as_recno+1 ||
	(!selector_used && offset != last_as_recno+1)) {
	/* Een PTT bug: als het voorlaatste entry voor een stad een .ds
	   verwijzing heeft, dan staat dezelfde verwijzing ook bij het laatste entry */
	if(!lastitem)
	  fprintf(stderr, "Interesting: %s %d: offset=%d last_recno=%d\n",
		  as_dosnaam, as_recno, offset, last_as_recno);
	return;
    }

    skip_ds_rec(offset - last_as_recno - 1);

    get_ds_rec(count);

    m = 0;
    while(count--) {
    /* expect: CAMPO IR M A I A,PRINSENGR 1011@  020@6241431@
       usually RANDOM TEXT@@@ */
	printf("\t");
	while((j = last_as_field.p[m++]) != 0)
	  putchar(tolower(j));
	printf("\n");

	offset++;
    }
}
